/*
	File:		CreditNowDemo.cpp
	Contains:	Implementation of the SOM class CreditNowDemo
	Written by:	PartMaker

	Change History (most recent first):

	<3>	4/18/95	JS		Updated to Developer Release 2
						Add ClonePartInfo.
						Inherited for InitPart, InitPartFromStorage.
						Fixed Externalize() inherited call.
						Removed inherited from Release().
						delete to ODDeleteObject().
	<2>	3/8/95	JS		Updated to b1c13/c14
	<1>	2/2/95	RA		first checked in
	<0>	PartMaker source by E. Soldan, T. elik, J. Alfke, R. Adkins, D. Nelson, J. Schalk
*/

#ifndef _ALTPOINT_
#include <AltPoint.h>
#endif

#ifndef SOM_ODFrame_xh
#include <Frame.xh>
#endif

#ifndef SOM_ODFacet_xh
#include <Facet.xh>
#endif

#ifndef SOM_ODShape_xh
#include <Shape.xh>
#endif

#ifndef SOM_ODDraft_xh
#include <Draft.xh>
#endif

#ifndef SOM_ODStorageUnit_xh
#include <StorageU.xh>
#endif

#ifndef SOM_ODTransform_xh
#include <Trnsform.xh>
#endif

#ifndef SOM_ODWindow_xh
#include <Window.xh>
#endif

#ifndef __QUICKDRAW__
#include <Quickdraw.h>
#endif

#ifndef _CPCREDITNOWDEMO_
#include "CPCreditNowDemo.h"
#endif

#define SOM_Module_creditnowdemo_Source
#define VARIABLE_MACROS

#ifndef SOM_AppropriateSolns_CreditNowDemo_xih
#include <CreditNowDemo.xih>
#endif

#ifndef _ODUTILS_
#include <ODUtils.h>
#endif

//========================================================================================
// AppropriateSolns_CreditNowDemo
//========================================================================================

SOM_Scope void  SOMLINK AppropriateSolns_CreditNowDemosomInit(AppropriateSolns_CreditNowDemo *somSelf)
{
    AppropriateSolns_CreditNowDemoData *somThis = AppropriateSolns_CreditNowDemoGetData(somSelf);
	_fCPPart = kODNULL;
    AppropriateSolns_CreditNowDemo_parent_ODPart_somInit(somSelf);
}

SOM_Scope void  SOMLINK AppropriateSolns_CreditNowDemosomUninit(AppropriateSolns_CreditNowDemo *somSelf)
{
    AppropriateSolns_CreditNowDemoData *somThis = AppropriateSolns_CreditNowDemoGetData(somSelf);
	if (_fCPPart)
		ODDeleteObject(_fCPPart);
    AppropriateSolns_CreditNowDemo_parent_ODPart_somUninit(somSelf);
}

SOM_Scope void  SOMLINK AppropriateSolns_CreditNowDemoFulfillPromise(AppropriateSolns_CreditNowDemo *somSelf,
		Environment *ev,
		ODStorageUnitView* promiseSUView)
{
    AppropriateSolns_CreditNowDemoData *somThis = AppropriateSolns_CreditNowDemoGetData(somSelf);
    _fCPPart->FulfillPromise(ev,promiseSUView);
}

SOM_Scope void  SOMLINK AppropriateSolns_CreditNowDemoDropCompleted(AppropriateSolns_CreditNowDemo *somSelf, 
		Environment *ev,
		ODPart* destPart,
		ODDropResult dropResult)
{
    AppropriateSolns_CreditNowDemoData *somThis = AppropriateSolns_CreditNowDemoGetData(somSelf);
    _fCPPart->DropCompleted(ev,destPart,dropResult);
}

SOM_Scope ODDragResult  SOMLINK AppropriateSolns_CreditNowDemoDragEnter(AppropriateSolns_CreditNowDemo *somSelf, 
		Environment *ev,
		ODDragItemIterator* dragInfo,
		ODFacet* facet,
		ODPoint* where)
{
    AppropriateSolns_CreditNowDemoData *somThis = AppropriateSolns_CreditNowDemoGetData(somSelf);
    return (_fCPPart->DragEnter(ev,dragInfo,facet,where));
}

SOM_Scope ODDragResult  SOMLINK AppropriateSolns_CreditNowDemoDragWithin(AppropriateSolns_CreditNowDemo *somSelf, 
		Environment *ev,
		ODDragItemIterator* dragInfo,
		ODFacet* facet,
		ODPoint* where)
{
    AppropriateSolns_CreditNowDemoData *somThis = AppropriateSolns_CreditNowDemoGetData(somSelf);
    return (_fCPPart->DragWithin(ev,dragInfo,facet,where));
}

SOM_Scope void  SOMLINK AppropriateSolns_CreditNowDemoDragLeave(AppropriateSolns_CreditNowDemo *somSelf, 
		Environment *ev,
		ODFacet* facet,
		ODPoint* where)
{
    AppropriateSolns_CreditNowDemoData *somThis = AppropriateSolns_CreditNowDemoGetData(somSelf);
    _fCPPart->DragLeave(ev,facet,where);
}

SOM_Scope ODDropResult  SOMLINK AppropriateSolns_CreditNowDemoDrop(AppropriateSolns_CreditNowDemo *somSelf, 
		Environment *ev,
		ODDragItemIterator* dropInfo,
		ODFacet* facet,
		ODPoint* where)
{
    AppropriateSolns_CreditNowDemoData *somThis = AppropriateSolns_CreditNowDemoGetData(somSelf);
    return (_fCPPart->Drop(ev,dropInfo,facet,where));
}

SOM_Scope void  SOMLINK AppropriateSolns_CreditNowDemoContainingPartPropertiesChanged(AppropriateSolns_CreditNowDemo *somSelf, 
		Environment *ev,
		ODFrame* frame,
		ODStorageUnit* propertyUnit)
{
    AppropriateSolns_CreditNowDemoData *somThis = AppropriateSolns_CreditNowDemoGetData(somSelf);
    _fCPPart->ContainingPartPropertiesChanged(ev,frame,propertyUnit);
}

SOM_Scope ODStorageUnit*  SOMLINK AppropriateSolns_CreditNowDemoGetContainingPartProperties(AppropriateSolns_CreditNowDemo *somSelf, 
		Environment *ev,
		ODFrame* frame)
{
    AppropriateSolns_CreditNowDemoData *somThis = AppropriateSolns_CreditNowDemoGetData(somSelf);
    return (_fCPPart->GetContainingPartProperties(ev,frame));
}

SOM_Scope ODBoolean  SOMLINK AppropriateSolns_CreditNowDemoRevealFrame(AppropriateSolns_CreditNowDemo *somSelf, 
		Environment *ev,
		ODFrame* embeddedFrame,
		ODShape* revealShape)
{
    AppropriateSolns_CreditNowDemoData *somThis = AppropriateSolns_CreditNowDemoGetData(somSelf);
    return (_fCPPart->RevealFrame(ev,embeddedFrame,revealShape));
}

SOM_Scope void  SOMLINK AppropriateSolns_CreditNowDemoEmbeddedFrameSpec(AppropriateSolns_CreditNowDemo *somSelf, 
		Environment *ev,
		ODFrame* embeddedFrame,
		ODObjectSpec* spec)
{
    AppropriateSolns_CreditNowDemoData *somThis = AppropriateSolns_CreditNowDemoGetData(somSelf);
    _fCPPart->EmbeddedFrameSpec(ev,embeddedFrame,spec);
}

SOM_Scope ODEmbeddedFramesIterator*  SOMLINK AppropriateSolns_CreditNowDemoCreateEmbeddedFramesIterator(AppropriateSolns_CreditNowDemo *somSelf, 
		Environment *ev,
		ODFrame* frame)
{
    AppropriateSolns_CreditNowDemoData *somThis = AppropriateSolns_CreditNowDemoGetData(somSelf);
    return (_fCPPart->CreateEmbeddedFramesIterator(ev,frame));
}

SOM_Scope void  SOMLINK AppropriateSolns_CreditNowDemoDisplayFrameAdded(AppropriateSolns_CreditNowDemo *somSelf, 
		Environment *ev,
		ODFrame* frame)
{
	AppropriateSolns_CreditNowDemoData *somThis = AppropriateSolns_CreditNowDemoGetData(somSelf);
    _fCPPart->DisplayFrameAdded(ev,frame);
}

SOM_Scope void  SOMLINK AppropriateSolns_CreditNowDemoDisplayFrameRemoved(AppropriateSolns_CreditNowDemo *somSelf, 
		Environment *ev,
		ODFrame* frame)
{
    AppropriateSolns_CreditNowDemoData *somThis = AppropriateSolns_CreditNowDemoGetData(somSelf);
    _fCPPart->DisplayFrameRemoved(ev,frame);
}

SOM_Scope void  SOMLINK AppropriateSolns_CreditNowDemoDisplayFrameConnected(AppropriateSolns_CreditNowDemo *somSelf, 
		Environment *ev,
		ODFrame* frame)
{
    AppropriateSolns_CreditNowDemoData *somThis = AppropriateSolns_CreditNowDemoGetData(somSelf);
    _fCPPart->DisplayFrameConnected(ev,frame);
}

SOM_Scope void  SOMLINK AppropriateSolns_CreditNowDemoDisplayFrameClosed(AppropriateSolns_CreditNowDemo *somSelf, 
		Environment *ev,
		ODFrame* frame)
{
    AppropriateSolns_CreditNowDemoData *somThis = AppropriateSolns_CreditNowDemoGetData(somSelf);
    _fCPPart->DisplayFrameClosed(ev,frame);
}

SOM_Scope void  SOMLINK AppropriateSolns_CreditNowDemoAttachSourceFrame(AppropriateSolns_CreditNowDemo *somSelf, 
		Environment *ev,
		ODFrame* frame,
		ODFrame* sourceFrame)
{
    AppropriateSolns_CreditNowDemoData *somThis = AppropriateSolns_CreditNowDemoGetData(somSelf);
    _fCPPart->AttachSourceFrame(ev,frame,sourceFrame);
}

SOM_Scope void  SOMLINK AppropriateSolns_CreditNowDemoFrameShapeChanged(AppropriateSolns_CreditNowDemo *somSelf, 
		Environment *ev,
		ODFrame* frame)
{
    AppropriateSolns_CreditNowDemoData *somThis = AppropriateSolns_CreditNowDemoGetData(somSelf);
    _fCPPart->FrameShapeChanged(ev,frame);
}

SOM_Scope void  SOMLINK AppropriateSolns_CreditNowDemoViewTypeChanged(AppropriateSolns_CreditNowDemo *somSelf, 
		Environment *ev,
		ODFrame* frame)
{
    AppropriateSolns_CreditNowDemoData *somThis = AppropriateSolns_CreditNowDemoGetData(somSelf);
    _fCPPart->ViewTypeChanged(ev,frame);
}

SOM_Scope void  SOMLINK AppropriateSolns_CreditNowDemoPresentationChanged(AppropriateSolns_CreditNowDemo *somSelf, 
		Environment *ev,
		ODFrame* frame)
{
    AppropriateSolns_CreditNowDemoData *somThis = AppropriateSolns_CreditNowDemoGetData(somSelf);
    _fCPPart->PresentationChanged(ev,frame);
}

SOM_Scope void  SOMLINK AppropriateSolns_CreditNowDemoSequenceChanged(AppropriateSolns_CreditNowDemo *somSelf, 
		Environment *ev,
		ODFrame* frame)
{
    AppropriateSolns_CreditNowDemoData *somThis = AppropriateSolns_CreditNowDemoGetData(somSelf);
    _fCPPart->SequenceChanged(ev,frame);
}

SOM_Scope void  SOMLINK AppropriateSolns_CreditNowDemoWritePartInfo(AppropriateSolns_CreditNowDemo *somSelf, 
		Environment *ev,
		ODInfoType partInfo,
		ODStorageUnitView* storageUnitView)
{
    AppropriateSolns_CreditNowDemoData *somThis = AppropriateSolns_CreditNowDemoGetData(somSelf);
    _fCPPart->WritePartInfo(ev,partInfo,storageUnitView);
}

SOM_Scope ODInfoType  SOMLINK AppropriateSolns_CreditNowDemoReadPartInfo(AppropriateSolns_CreditNowDemo *somSelf, 
		Environment *ev,
		ODFrame* frame,
		ODStorageUnitView* storageUnitView)
{
    AppropriateSolns_CreditNowDemoData *somThis = AppropriateSolns_CreditNowDemoGetData(somSelf);
    return (_fCPPart->ReadPartInfo(ev,frame,storageUnitView));
}

SOM_Scope void  SOMLINK AppropriateSolns_CreditNowDemoClonePartInfo(AppropriateSolns_CreditNowDemo *somSelf, 
		Environment *ev,
		ODDraftKey key,
		ODInfoType partInfo,
		ODStorageUnitView* storageUnitView,
		ODFrame* scopeFrame)
{
    AppropriateSolns_CreditNowDemoData *somThis = AppropriateSolns_CreditNowDemoGetData(somSelf);
    _fCPPart->ClonePartInfo(ev,key,partInfo,storageUnitView,scopeFrame);
}

SOM_Scope ODID  SOMLINK AppropriateSolns_CreditNowDemoOpen(AppropriateSolns_CreditNowDemo *somSelf,
		Environment *ev,
		ODFrame* frame)
{
    AppropriateSolns_CreditNowDemoData *somThis = AppropriateSolns_CreditNowDemoGetData(somSelf);
	return (_fCPPart->Open(ev,frame));
}

SOM_Scope ODFrame*  SOMLINK AppropriateSolns_CreditNowDemoRequestEmbeddedFrame(AppropriateSolns_CreditNowDemo *somSelf, 
		Environment *ev,
		ODFrame* containingFrame,
		ODFrame* baseFrame,
		ODShape* frameShape,
		ODPart* embedPart,
		ODTypeToken viewType,
		ODTypeToken presentation,
		ODBoolean isOverlaid)
{
    AppropriateSolns_CreditNowDemoData *somThis = AppropriateSolns_CreditNowDemoGetData(somSelf);
	return (_fCPPart->RequestEmbeddedFrame(ev,containingFrame,baseFrame,frameShape,embedPart,viewType,presentation,isOverlaid));
}

SOM_Scope void  SOMLINK AppropriateSolns_CreditNowDemoRemoveEmbeddedFrame(AppropriateSolns_CreditNowDemo *somSelf, 
		Environment *ev,
		ODFrame* embeddedFrame)
{
    AppropriateSolns_CreditNowDemoData *somThis = AppropriateSolns_CreditNowDemoGetData(somSelf);
    _fCPPart->RemoveEmbeddedFrame(ev,embeddedFrame);
}

SOM_Scope ODShape*  SOMLINK AppropriateSolns_CreditNowDemoRequestFrameShape(AppropriateSolns_CreditNowDemo *somSelf, 
		Environment *ev,
		ODFrame* embeddedFrame,
		ODShape* frameShape)
{
    AppropriateSolns_CreditNowDemoData *somThis = AppropriateSolns_CreditNowDemoGetData(somSelf);
	return (_fCPPart->RequestFrameShape(ev,embeddedFrame,frameShape));
}

SOM_Scope void  SOMLINK AppropriateSolns_CreditNowDemoUsedShapeChanged(AppropriateSolns_CreditNowDemo *somSelf, 
		Environment *ev,
		ODFrame* embeddedFrame)
{
    AppropriateSolns_CreditNowDemoData *somThis = AppropriateSolns_CreditNowDemoGetData(somSelf);
    _fCPPart->UsedShapeChanged(ev,embeddedFrame);
}

SOM_Scope ODShape*  SOMLINK AppropriateSolns_CreditNowDemoAdjustBorderShape(AppropriateSolns_CreditNowDemo *somSelf, 
		Environment *ev,
		ODFacet* embeddedFacet,
		ODShape* shape)
{
    AppropriateSolns_CreditNowDemoData *somThis = AppropriateSolns_CreditNowDemoGetData(somSelf);
    return (_fCPPart->AdjustBorderShape(ev,embeddedFacet,shape));
}

SOM_Scope void  SOMLINK AppropriateSolns_CreditNowDemoFacetAdded(AppropriateSolns_CreditNowDemo *somSelf, 
		Environment *ev,
		ODFacet* facet)
{
    AppropriateSolns_CreditNowDemoData *somThis = AppropriateSolns_CreditNowDemoGetData(somSelf);
    _fCPPart->FacetAdded(ev,facet);
}

SOM_Scope void  SOMLINK AppropriateSolns_CreditNowDemoFacetRemoved(AppropriateSolns_CreditNowDemo *somSelf, 
		Environment *ev,
		ODFacet* facet)
{
    AppropriateSolns_CreditNowDemoData *somThis = AppropriateSolns_CreditNowDemoGetData(somSelf);
	_fCPPart->FacetRemoved(ev,facet);
}

SOM_Scope void  SOMLINK AppropriateSolns_CreditNowDemoCanvasChanged(AppropriateSolns_CreditNowDemo *somSelf, 
		Environment *ev,
		ODFacet* facet)
{
    AppropriateSolns_CreditNowDemoData *somThis = AppropriateSolns_CreditNowDemoGetData(somSelf);
	_fCPPart->CanvasChanged(ev,facet);
}

SOM_Scope void  SOMLINK AppropriateSolns_CreditNowDemoGeometryChanged(AppropriateSolns_CreditNowDemo *somSelf, 
		Environment *ev,
		ODFacet* facet,
		ODBoolean clipShapeChanged,
		ODBoolean externalTransformChanged)
{
    AppropriateSolns_CreditNowDemoData *somThis = AppropriateSolns_CreditNowDemoGetData(somSelf);
	_fCPPart->GeometryChanged(ev,facet,clipShapeChanged,externalTransformChanged);
}

SOM_Scope void  SOMLINK AppropriateSolns_CreditNowDemoDraw(AppropriateSolns_CreditNowDemo *somSelf, 
		Environment *ev,
		ODFacet* facet,
		ODShape* invalidShape)
{
    AppropriateSolns_CreditNowDemoData *somThis = AppropriateSolns_CreditNowDemoGetData(somSelf);
	_fCPPart->Draw(ev,facet,invalidShape);
}

SOM_Scope void  SOMLINK AppropriateSolns_CreditNowDemoCanvasUpdated(AppropriateSolns_CreditNowDemo *somSelf, 
		Environment *ev,
		ODCanvas* canvas)
{
    AppropriateSolns_CreditNowDemoData *somThis = AppropriateSolns_CreditNowDemoGetData(somSelf);
	_fCPPart->CanvasUpdated(ev,canvas);
}

SOM_Scope void  SOMLINK AppropriateSolns_CreditNowDemoHighlightChanged(AppropriateSolns_CreditNowDemo *somSelf, 
		Environment *ev,
		ODFacet* facet)
{
    AppropriateSolns_CreditNowDemoData *somThis = AppropriateSolns_CreditNowDemoGetData(somSelf);
	_fCPPart->HighlightChanged(ev,facet);
}

SOM_Scope ODULong  SOMLINK AppropriateSolns_CreditNowDemoGetPrintResolution(AppropriateSolns_CreditNowDemo *somSelf, 
		Environment *ev,
		ODFrame* frame)
{
    AppropriateSolns_CreditNowDemoData *somThis = AppropriateSolns_CreditNowDemoGetData(somSelf);
	return (_fCPPart->GetPrintResolution(ev,frame));
}

SOM_Scope ODLinkSource*  SOMLINK AppropriateSolns_CreditNowDemoCreateLink(AppropriateSolns_CreditNowDemo *somSelf, 
		Environment *ev,
		ODByteArray* data)
{
    AppropriateSolns_CreditNowDemoData *somThis = AppropriateSolns_CreditNowDemoGetData(somSelf);
	return (_fCPPart->CreateLink(ev,data));
}

SOM_Scope void  SOMLINK AppropriateSolns_CreditNowDemoLinkUpdated(AppropriateSolns_CreditNowDemo *somSelf, 
		Environment *ev,
		ODLink* updatedLink,
		ODChangeID id)
{
    AppropriateSolns_CreditNowDemoData *somThis = AppropriateSolns_CreditNowDemoGetData(somSelf);
	_fCPPart->LinkUpdated(ev,updatedLink,id);
}

SOM_Scope void  SOMLINK AppropriateSolns_CreditNowDemoRevealLink(AppropriateSolns_CreditNowDemo *somSelf, 
		Environment *ev,
		ODLinkSource* linkSource)
{
    AppropriateSolns_CreditNowDemoData *somThis = AppropriateSolns_CreditNowDemoGetData(somSelf);
	_fCPPart->RevealLink(ev,linkSource);
}

SOM_Scope void  SOMLINK AppropriateSolns_CreditNowDemoEmbeddedFrameChanged(AppropriateSolns_CreditNowDemo *somSelf, 
		Environment *ev,
		ODFrame* frame,
		ODChangeID change)
{
    AppropriateSolns_CreditNowDemoData *somThis = AppropriateSolns_CreditNowDemoGetData(somSelf);
	_fCPPart->EmbeddedFrameChanged(ev,frame,change);
}

SOM_Scope void  SOMLINK AppropriateSolns_CreditNowDemoLinkStatusChanged(AppropriateSolns_CreditNowDemo *somSelf, 
		Environment *ev,
		ODFrame* frame)
{
    AppropriateSolns_CreditNowDemoData *somThis = AppropriateSolns_CreditNowDemoGetData(somSelf);
	_fCPPart->LinkStatusChanged(ev,frame);
}

SOM_Scope ODBoolean  SOMLINK AppropriateSolns_CreditNowDemoBeginRelinquishFocus(AppropriateSolns_CreditNowDemo *somSelf, 
		Environment *ev,
		ODTypeToken focus,
		ODFrame* ownerFrame,
		ODFrame* proposedFrame)
{
    AppropriateSolns_CreditNowDemoData *somThis = AppropriateSolns_CreditNowDemoGetData(somSelf);
	return (_fCPPart->BeginRelinquishFocus(ev,focus,ownerFrame,proposedFrame));
}

SOM_Scope void  SOMLINK AppropriateSolns_CreditNowDemoCommitRelinquishFocus(AppropriateSolns_CreditNowDemo *somSelf, 
		Environment *ev,
		ODTypeToken focus,
		ODFrame* ownerFrame,
		ODFrame* proposedFrame)
{
    AppropriateSolns_CreditNowDemoData *somThis = AppropriateSolns_CreditNowDemoGetData(somSelf);
	_fCPPart->CommitRelinquishFocus(ev,focus,ownerFrame,proposedFrame);
}

SOM_Scope void  SOMLINK AppropriateSolns_CreditNowDemoAbortRelinquishFocus(AppropriateSolns_CreditNowDemo *somSelf, 
		Environment *ev,
		ODTypeToken focus,
		ODFrame* ownerFrame,
		ODFrame* proposedFrame)
{
    AppropriateSolns_CreditNowDemoData *somThis = AppropriateSolns_CreditNowDemoGetData(somSelf);
	_fCPPart->AbortRelinquishFocus(ev,focus,ownerFrame,proposedFrame);
}

SOM_Scope void  SOMLINK AppropriateSolns_CreditNowDemoFocusAcquired(AppropriateSolns_CreditNowDemo *somSelf, 
		Environment *ev,
		ODTypeToken focus,
		ODFrame* ownerFrame)
{
    AppropriateSolns_CreditNowDemoData *somThis = AppropriateSolns_CreditNowDemoGetData(somSelf);
	_fCPPart->FocusAcquired(ev,focus,ownerFrame);
}

SOM_Scope void  SOMLINK AppropriateSolns_CreditNowDemoFocusLost(AppropriateSolns_CreditNowDemo *somSelf, 
		Environment *ev,
		ODTypeToken focus,
		ODFrame* ownerFrame)
{
    AppropriateSolns_CreditNowDemoData *somThis = AppropriateSolns_CreditNowDemoGetData(somSelf);
	_fCPPart->FocusLost(ev,focus,ownerFrame);
}

SOM_Scope ODBoolean  SOMLINK AppropriateSolns_CreditNowDemoHasExtension(AppropriateSolns_CreditNowDemo *somSelf, 
		Environment *ev,
		ODType extensionName)
{
    AppropriateSolns_CreditNowDemoData *somThis = AppropriateSolns_CreditNowDemoGetData(somSelf);
	return (_fCPPart->HasExtension(ev,extensionName));
}

SOM_Scope ODExtension*  SOMLINK AppropriateSolns_CreditNowDemoGetExtension(AppropriateSolns_CreditNowDemo *somSelf, 
		Environment *ev,
		ODType extensionName)
{
    AppropriateSolns_CreditNowDemoData *somThis = AppropriateSolns_CreditNowDemoGetData(somSelf);
	return (_fCPPart->GetExtension(ev,extensionName));
}

SOM_Scope void  SOMLINK AppropriateSolns_CreditNowDemoReleaseExtension(AppropriateSolns_CreditNowDemo *somSelf, 
		Environment *ev,
		ODExtension* extension)
{
    AppropriateSolns_CreditNowDemoData *somThis = AppropriateSolns_CreditNowDemoGetData(somSelf);
	_fCPPart->ReleaseExtension(ev,extension);
}

SOM_Scope ODSize  SOMLINK AppropriateSolns_CreditNowDemoPurge(AppropriateSolns_CreditNowDemo *somSelf, 
		Environment *ev,
		ODSize size)
{
    AppropriateSolns_CreditNowDemoData *somThis = AppropriateSolns_CreditNowDemoGetData(somSelf);
    if  (_fCPPart)
		return (_fCPPart->Purge(ev,size));
	else
		return (AppropriateSolns_CreditNowDemo_parent_ODPart_Purge(somSelf,ev,size));
}

SOM_Scope void  SOMLINK AppropriateSolns_CreditNowDemoIncrementRefCount(AppropriateSolns_CreditNowDemo *somSelf, 
		Environment *ev)
{
    AppropriateSolns_CreditNowDemoData *somThis = AppropriateSolns_CreditNowDemoGetData(somSelf);
    AppropriateSolns_CreditNowDemo_parent_ODPart_IncrementRefCount(somSelf,ev);

	_fCPPart->IncrementRefCount(ev);
}

SOM_Scope void  SOMLINK AppropriateSolns_CreditNowDemoRelease(AppropriateSolns_CreditNowDemo *somSelf, 
		Environment *ev)
{
    AppropriateSolns_CreditNowDemoData *somThis = AppropriateSolns_CreditNowDemoGetData(somSelf);
    AppropriateSolns_CreditNowDemo_parent_ODPart_Release(somSelf,ev);

    if (_fCPPart)
    	_fCPPart->Release(ev);
    	
	if (somSelf->GetRefCount(ev) == 0)
		somSelf->GetStorageUnit(ev)->GetDraft(ev)->ReleasePart(ev, somSelf);
}

SOM_Scope void  SOMLINK AppropriateSolns_CreditNowDemoReleaseAll(AppropriateSolns_CreditNowDemo *somSelf, 
		Environment *ev)
{
    AppropriateSolns_CreditNowDemoData *somThis = AppropriateSolns_CreditNowDemoGetData(somSelf);
    _fCPPart->ReleaseAll(ev);
}

SOM_Scope void  SOMLINK AppropriateSolns_CreditNowDemoExternalize(AppropriateSolns_CreditNowDemo *somSelf, 
		Environment *ev)
{
    AppropriateSolns_CreditNowDemoData *somThis = AppropriateSolns_CreditNowDemoGetData(somSelf);
	AppropriateSolns_CreditNowDemo_parent_ODPart_Externalize(somSelf,ev);

	_fCPPart->Externalize(ev);
}

SOM_Scope void  SOMLINK AppropriateSolns_CreditNowDemoCloneInto(AppropriateSolns_CreditNowDemo *somSelf, 
		Environment *ev,
		ODDraftKey key,
		ODStorageUnit* storageUnit,
		ODFrame* initiatingFrame)
{
    AppropriateSolns_CreditNowDemoData *somThis = AppropriateSolns_CreditNowDemoGetData(somSelf);
	AppropriateSolns_CreditNowDemo_parent_ODPart_CloneInto(somSelf,ev,key,storageUnit,initiatingFrame);

    _fCPPart->CloneInto(ev,key,storageUnit,initiatingFrame);
}

SOM_Scope void  SOMLINK AppropriateSolns_CreditNowDemoExternalizeKinds(AppropriateSolns_CreditNowDemo *somSelf, 
		Environment *ev,
		ODTypeList* kindset)
{
    AppropriateSolns_CreditNowDemoData *somThis = AppropriateSolns_CreditNowDemoGetData(somSelf);
    _fCPPart->ExternalizeKinds(ev,kindset);
}

SOM_Scope void  SOMLINK AppropriateSolns_CreditNowDemoChangeKind(AppropriateSolns_CreditNowDemo *somSelf, 
		Environment *ev,
		ODType kind)
{
    AppropriateSolns_CreditNowDemoData *somThis = AppropriateSolns_CreditNowDemoGetData(somSelf);
    _fCPPart->ChangeKind(ev,kind);
}

SOM_Scope ODBoolean  SOMLINK AppropriateSolns_CreditNowDemoHandleEvent(AppropriateSolns_CreditNowDemo *somSelf, 
		Environment *ev,
		ODEventData* event,
		ODFrame* frame,
		ODFacet* facet,
		ODEventInfo* eventInfo)
{
    AppropriateSolns_CreditNowDemoData *somThis = AppropriateSolns_CreditNowDemoGetData(somSelf);
    return (_fCPPart->HandleEvent(ev,event,frame,facet,eventInfo));
}

SOM_Scope void  SOMLINK AppropriateSolns_CreditNowDemoAdjustMenus(AppropriateSolns_CreditNowDemo *somSelf, 
		Environment *ev,
		ODFrame* frame)
{
    AppropriateSolns_CreditNowDemoData *somThis = AppropriateSolns_CreditNowDemoGetData(somSelf);
    _fCPPart->AdjustMenus(ev,frame);
}

SOM_Scope void  SOMLINK AppropriateSolns_CreditNowDemoUndoAction(AppropriateSolns_CreditNowDemo *somSelf, 
		Environment *ev,
		ODActionData* actionState)
{
    AppropriateSolns_CreditNowDemoData *somThis = AppropriateSolns_CreditNowDemoGetData(somSelf);
    _fCPPart->UndoAction(ev,actionState);
}

SOM_Scope void  SOMLINK AppropriateSolns_CreditNowDemoRedoAction(AppropriateSolns_CreditNowDemo *somSelf, 
		Environment *ev,
		ODActionData* actionState)
{
    AppropriateSolns_CreditNowDemoData *somThis = AppropriateSolns_CreditNowDemoGetData(somSelf);
    _fCPPart->RedoAction(ev,actionState);
}

SOM_Scope void  SOMLINK AppropriateSolns_CreditNowDemoDisposeActionState(AppropriateSolns_CreditNowDemo *somSelf, 
		Environment *ev,
		ODActionData* actionState,
		ODDoneState doneState)
{
    AppropriateSolns_CreditNowDemoData *somThis = AppropriateSolns_CreditNowDemoGetData(somSelf);
    _fCPPart->DisposeActionState(ev,actionState,doneState);
}

SOM_Scope void  SOMLINK AppropriateSolns_CreditNowDemoWriteActionState(AppropriateSolns_CreditNowDemo *somSelf, 
		Environment *ev,
		ODActionData* actionState,
		ODStorageUnitView* storageUnitView)
{
    AppropriateSolns_CreditNowDemoData *somThis = AppropriateSolns_CreditNowDemoGetData(somSelf);
    _fCPPart->WriteActionState(ev,actionState,storageUnitView);
}

SOM_Scope ODActionData  SOMLINK AppropriateSolns_CreditNowDemoReadActionState(AppropriateSolns_CreditNowDemo *somSelf, 
		Environment *ev,
		ODStorageUnitView* storageUnitView)
{
    AppropriateSolns_CreditNowDemoData *somThis = AppropriateSolns_CreditNowDemoGetData(somSelf);
    return (_fCPPart->ReadActionState(ev,storageUnitView));
}

SOM_Scope void  SOMLINK AppropriateSolns_CreditNowDemoInitPart(AppropriateSolns_CreditNowDemo *somSelf,
		Environment *ev,
		ODStorageUnit* storageUnit, ODPart* partWrapper)
{
    AppropriateSolns_CreditNowDemoData *somThis = AppropriateSolns_CreditNowDemoGetData(somSelf);
	if (somSelf->IsInitialized(ev))
		return;
	
	AppropriateSolns_CreditNowDemo_parent_ODPart_InitPart(somSelf,ev,storageUnit,partWrapper);
	
    _fCPPart = new CPCreditNowDemo; // $$$$$ Check to see if it is nil
    _fCPPart->InitPart(ev,storageUnit, (ODPart*)partWrapper);
}

SOM_Scope void  SOMLINK AppropriateSolns_CreditNowDemoInitPartFromStorage(AppropriateSolns_CreditNowDemo *somSelf, 
		Environment *ev,
		ODStorageUnit* storageUnit, ODPart* partWrapper)
{
    AppropriateSolns_CreditNowDemoData *somThis = AppropriateSolns_CreditNowDemoGetData(somSelf);
	if (somSelf->IsInitialized(ev))
		return;

	AppropriateSolns_CreditNowDemo_parent_ODPart_InitPartFromStorage(somSelf,ev,storageUnit,partWrapper);
	
    _fCPPart = new CPCreditNowDemo; // $$$$$ Check to see if it is nil
	_fCPPart->InitPartFromStorage(ev,storageUnit, (ODPart*)partWrapper);
}

